#ifndef _BSHIP_GAMEPIECE_H
#define _BSHIP_GAMEPIECE_H

#include <View.h>

typedef enum {
	none = -1,
	destroyer,	//----2 spaces
	submarine,	//----3 spaces
	cruiser, 	//----3 spaces
	battleship,	//----4 spaces
	carrier		//----5 spaces
} ship_type;

extern const uint8 ship_length[];
extern const char ship_signal[];
extern const char *ship_name[];
extern char us[255];

enum {
	HIT_SQUARE,
	HIT_RESULT,
	SHIP_SUNK,
	PLAY_BALL,
	YOUR_TURN,
	HI,
	HI_REJECT,
	YOU_LOSE
};

class square : public BView {
	public:
		square(int board,int x, int y);
		void SetShip(ship_type ship, int position, int direction);
		void Hit();
		virtual	void			Draw(BRect updateRect);
		virtual	void MouseDown(BPoint where);
	private:
		friend class GameBoard;
		int place, pos;
		int x,y;
		int board_type;
		ship_type ship;
		int hit;
};

#endif
