#ifndef _BSHIP_WINDOW_H
#define _BSHIP_WINDOW_H

#include <Window.h>

#include "gamepiece.h"
#include "GameSession.h"

extern bool our_turn;

namespace muscle {
	class MessageTransceiverThread;
}

class GameBoard : public BWindow, public GameSession {
	public:
		GameBoard(const char *IP = "beshare.tycomsystems.com");
		void Hit(ship_type ship);
		void MessageReceived(BMessage *msg);
        bool QuitRequested(void);
        
        virtual void PartnerGone(); //-----Partner has disappeared
		
		virtual void NewUserLoggedOn(int32 id, const char *name);
		virtual void UserLoggedOff(int32 id, const char *name);
		
		virtual void ServerDisconnected(); //----The *server* has died, this prompts immediate suicide
		virtual void ServerConnectDone(); //-----Connected to *server*		
		virtual bool AllowConnectFrom(const char *user_name, int32 id);
		
		virtual void MessageReceivedFromPartner(muscle::MessageRef msg);
         
        ship_type placing;
        int lastx, lasty;
        
	protected:
		virtual const char * GetTypeName() const;
		
	private:
		void PrepareBoardForPlayTime(const char *user);
	
		bool partner_ready;
		bool accept;
		bool connected;
		BStringView *status, *chat_display;
		BTextControl *name_box, *chat;
		BListView *players;
		BScrollView *playersbox;
		square *squares[2][10][10];
		muscle::String host, opponent_name;
		int ship_count[5];
		int ships_sunk;
		
		friend class square;
};

#endif
